#!/usr/bin/env python

# Usage :
# placer le script  la racine du rpertoire 'tiny', juste sous a1, a2, etc...
# et lui donner les droits d'excution
# commande './maketiny a' ou './maketiny xapp', etc... (le nom du paquet)

# lit: tagfile.org, 'disk%s1'
# crit: tagfile, 'disk%s1'
 
import string, re, sys, os, glob

basedir = '.'
argument = sys.argv[1]

disk = re.compile(argument+'[1-9][0-9]*')   # les bons rpertoires (disquettes)
disk1 = argument+'1'                       # le rpertoire (disquette) numro 1
paquet = re.compile('.tgz$')                # un paquet, dans rpertoire
nom = re.compile('^([a-z][a-z0-9_]+):')              # un nom de paquet, dans fichier

liste_paq = []                   # liste des paquets dans tous rpertoires
ddict_ppaq = {}                 # dict des paquets -> doc de l'index ('diska2')
dict_ppaq = {}                   # dict des paquets dans chaque rpertoire
liste_disq = []                  # liste des rpertoires (disquettes)

def maketiny():
    prepare()
    writetagfile()
    writeindexes()

def prepare():
    for d in os.listdir(basedir):
        if disk.match(d):
            analyse(os.path.join(basedir,d,'disk'+d))
            liste_disq.append(d)
            liste = []
            for f in os.listdir(os.path.join(basedir, d)):
                if paquet.search(f):
                    liste.append(paquet.sub('',f))
                    liste_paq.append(paquet.sub('',f))
            dict_ppaq[d] = liste
    

def analyse(index):
    """ l je prends la doc de l'index et je la mets dans ddict_ppaq"""
    lignes = open(index,'r').readlines()
    ligne_ = []
    n = ''
    for ligne in lignes:
        match = nom.match(ligne)
        if match:
            g = match.group(1)
            if g==n:
                ligne_.append(ligne)
            else:
                if (n!=''):
                    ddict_ppaq[n] = ligne_
                n = g
                ligne_ = [ligne]
    if (n!=''):
        ddict_ppaq[n] = ligne_


def writetagfile():
    """
    utilise 'tagfile.org'
    produit 'tagfile'
    """
    liste_noms = []
    resultat = open(os.path.join(basedir,disk1,'tagfile'),'w')
    lignes = open(os.path.join(basedir,disk1,'tagfile.org'),'r').readlines()
    for ligne in lignes:
        match = nom.match(ligne)
        if not match:
            resultat.write(ligne)
        if match:
            n = match.group(1)
            #print n
            if n in liste_paq:
                liste_noms.append(n)
                resultat.write(ligne)

def writeindex(rep):
    """
    # (non)sauvegarde 'diska1' en 'diska1.org'
    puis le reconstruit avec les vrais paquets du rep
    """
    #os.rename(os.path.join(basedir,rep,'disk'+rep),os.path.join(basedir,rep,'disk'+rep+'.org'))
    resultat = open(os.path.join(basedir,rep,'disk'+rep),'w')
    paquets = dict_ppaq[rep]
    cles = ddict_ppaq.keys()
    cles.sort()
    print cles
    for cle in cles:
        if cle in paquets: 
            resultat.write(string.join(ddict_ppaq[cle],''))

def writeindexes():
    for d in liste_disq:
        writeindex(d)

if __name__=='__main__': maketiny()










